/*
	Write by xempo 9 2014
	Free under LGPL
*/

#ifndef  Financ_Stocks
#define  Financ_Stocks

#include <qmainwindow.h>
#include <qaction.h>
#include <qlabel.h>
#include "filesan.h"
#include "genset.h"

#define  StocksDAU  6

typedef struct _fieldNode {
LVItem *it;
int num, dyNum;
bool mdf;
}FieldNode;

class FinaStocks : public QMainWindow
{
 moc_Object

friend int readNum(__ORD *dir, BYTE *unit);

public:
FinaStocks( QWidget* parent);
void showTop();
//   ~FinaStocks();
bool exe(const char *cap, const char **lst, int img);

bool modified(LVItem *it)
{
	if(subAdding){
		subAdding=false;
		if(it->getTypeOr()==5/*type_recentprice*/){
			LVItem *itm=(LVItem *)it->firstChild();
			int i;
			for(i=0; i<2; i++)it->setText(i+1, itm->text(i));
			delete itm;
			}
		else delete it;
		return true;
	}
	return false;
}

protected :
virtual  bool event(QEvent *e);

private:
ListContent *vlist;
QToolBar *tb;
StatusPanel *sbar;

const char **_stocks_, *stockName;
QAction *helpAct, *saveAct, *upAct, *downAct, *addAct, *removeAct, *mdfAct,
	*subAddAct, *buyAct, *priceAct, *cashInAct, *cashOutAct;
FieldNode *fieldNodes;
int nodCnt, nodPre;
FieldNode *tash;
int tashCnt, tashPre;
__ORD *StocksDir;
QTextCodec *utf8code;
bool mdf, setCap, subAdding;
float dyAchie;
int mdf_val, dyAchieCount, orgPrice, Cnt,
	_isMax;
long long moneyInOut, money, exchangVal, stockNum,
	t_Money, surplusVal, t_stocksVal, t_exchangVal;
char pricBuf[80], numBuf[80];
bool fspSave();

LVItem *lastStocks();
LVItem *subFieldCreat(LVItem *it, LVItem *sit, const char *chs, int field, MAU *);
LVItem *backSibling(LVItem *it, int *);
void creatCountField();
void mdfCountField(int lmt=5);
int getMoney(const char *txt);
LVItem *getField(LVItem *it0, int idx);
LVItem *getStocks();
FieldNode *getNode(LVItem *stocks);
void priceCount(int sw, LVItem *field, int recprice);
void exchangCount(LVItem *stock1);
void subCount(LVItem *it0);
void achieCount(LVItem *achiefield);
int readNumb(__ORD *dir, BYTE *unit);
};

extern const char fspStocks[], finaStocks[];
extern QPtrList <FinaStocks> stocksList;

#endif
