/*
	Write & edit by Linjianghua 2005-06,2008-2010, 2012
	Free under LGPL
*/

#include "ordir.h"
#include "infor.h"

void ORDopera(__ORL *lib,char **pm, int nCom)
{
  char *dname;
  __ORD *dir=ORDparent(lib->CurDir,*pm, &dname);
  if(idxdscpt>0x7ffd){
	switch(nCom){
	case ORL_erase :
	case ORL_ndels :
	case ORL_empty : /* dname=(char *)DirOpen(dir,dname); cvt to send */
	case ORL_del :
	case ORL_rmdir : ORDdel(dir,dname,nCom);
		break;
	case ORL_ren :
	case ORL_rendir : ORDren(dir,dname,pm[1]);
	}
	ORDclose(dir,1);
  }
  else reportBug();
}

void NumOpera(__ORL *lib,char **pm, int nCom)
{
  int numb;
  BOOL rt;
  __ORD *dir=ORDopen(lib->CurDir,divPath(*pm,&numb), DIR_READ);
  if(idxdscpt>0x7ffd){
	switch(nCom){
	case ORL_ren : 
	case ORL_rename : rt=NumRen(dir,numb,atol(pm[1]));
		break;
	case ORL_erase :  del_mode=ORL_erase;
	default : rt=NumDel(dir,numb); /* 2105, 2106=rm */
	}
	if(rt==False)reportBug();/* num 实时报错，不同dir, it loop */
	ORDclose(dir,1);
  }
  else reportBug();
}

void ORDundell(__ORL *lib,char *dirnam)
{
  __ORD *dir=ORDopen(lib->CurDir,dirnam,DIR_READ);
  if(idxdscpt>0x7ffd){
    DirFCU *du1;
     if((du1=ORDseek(dir,(char *)SPC, DIR_RESCUE))!=NULL){
	kRedir=0;
	if(undelPd(dir, du1)){
		_step=1;
	     if(FCU_ORDmdf(dir, du1, DIR_RESCUE)==1){
		if(getMsg){
			char buf[1024];
			sprintf(buf, "  Rescue dir : <font color=#a94030><u> %s </u></font>",du1->name);
			msgShow(buf);
			}
		else printf("  Rescue dir : \033[7m%s\033[0m\n",du1->name);
		}
		}
	free(du1);
    }
    else defaultHB( NoRescuDir_25 );
    ORDclose(dir,1);
  }
  else reportBug();
}

int NumUndel(__ORL *lib,char *dirnam, int n )
{
  __ORD *dir=ORDopen(lib->CurDir,dirnam,DIR_READ);
  int rt=0;
  if(idxdscpt>0x7ffd){
    BYTE *unit;
    if((unit=seekFCU(dir,0,NULL,NUMB_RESCUE))!=NULL){
	kRescue=0;
	rt=undelNum(dir, unit,  lib->FCU_dyw);
	if(rt==1){
		if(getMsg){
			char buf[80];
			sprintf(buf, "  Rescue %d", isZero(dir->Format) ? dir->NumbForZero:*(int *)(unit+FCU_NumPos));
			msgShow(buf);
			}
		else printf("  Rescue %d\n", isZero(dir->Format) ? dir->NumbForZero:*(int *)(unit+FCU_NumPos));
	}
	free(unit);
	}
    else if(n<1)defaultHB(NoReCover_23);
    ORDclose(dir,1);
  }
  else reportBug();
return rt;
}

