/*
	Write by xempo(LinJiangHua)
	Free under LGPL
*/

#include "ordir.h"
#include "shellcom.h"
#include "read.h"
#include "write.h"
#include "dlist.h"
#include "export.h"
#include <unistd.h>
#include <dirent.h>
#include <sys/errno.h>

int NumRand(__ORD *dir)
{
int numb=0;
BYTE *fcu;
while( (fcu=NumSeek(dir, numb, NUMB_READ)) ){
	numb++;
	free(fcu);
}
return numb;
}

#define force  pagemore

__ORD *ORDuse(__ORD *dir, char *dn)
{
__ORD *dir1;
static const un_Int pms[pd_param_cnt]={ 0, 12, 5, 2, (1|2)/* RW */ };
dir1=ORDcreat(dir, dn, pms);
if(idxdscpt==DirExist_9)dir1=ORDopen(dir, dn, DIR_READ);
return dir1;
}

int imagOD(__ORD *dir, const char *dn, const char *flt)
{
  int rt=1;
  DIR *osdir=opendir(dn);
  if(osdir==NULL){
	perror(dn);
	return -1;
	}
  struct stat64 st;
  struct dirent *dent;
  char bu[16], *pms[3], *fn, *ospth, *pExt;
  pms[0]=bu;   pms[1]=(char *)malloc(2048);  pms[2]=NULL;
  while( rt && (dent=readdir(osdir)) ){
	fn=dent->d_name;
	if(strcmp(fn, ".")==0 || strcmp(fn, "..")==0 )continue;
	ospth=catstr(dn, fn, '/');
	if(stat64(ospth, &st)==0){
	    if(S_ISDIR(st.st_mode)){
		__ORD *dir1=ORDuse(dir, fn);
		if(idxdscpt>0x7ffd){
			rt=imagOD(dir1, ospth, flt);
			ORDclose(dir1, 1);
			}
		}
	    else if(namefilters(fn,flt, 1)){
		sprintf(bu, "%d", NumRand(dir));
		if(dir->DAUC>1){
			sprintf(pms[1], "%s %s", ospth, fn);
			pExt="fv";
			}
		else { sprintf(pms[1], "%s", ospth); pExt="f"; }
		NumInsert(dir, 2, pms, pExt, ORL_insert, 0);/* env 0bit: append */
		}
	    }
	free(ospth);
	}
  free(pms[1]);
  closedir(osdir);
  return rt;
}

static const char *osimgdn, *dnth;
int qu_mode;
static int n_expimg(__ORD *dir,BYTE *fcu)
{
  int i, Z=isZero(dir->Format);
  for(i=0; i<dir->Num_FCUs_Block; i++,fcu+=dir->Num_FCU_Len ){
	if((*fcu&3)==1 && (qu_mode||(fcu[1]&ORL_MH)==0) ){
		char bu[16], *dst;
		sprintf(bu, "%d", (Z ? dir->NumbForZero : *(int *)(fcu+FCU_NumPos)) );
		dst=catstr(dnth, bu, '/');
		read_ar(dir, fcu, dst, 0, force);/* Z have nmb++  inside*/
		free(dst);
		}
	else if(Z)dir->NumbForZero++;
	}
  return 1;
}

static int d_expimg(__ORD *pdir,__ORD *dir)
{
if( (dir->mode&ORL_MH)==0 /*canAccess(dir->mode)*/ ){
  char *pt=ORDpath(dir,/*dir->lib->CurDir*/ NULL, 0);
  if(dnth!=osimgdn)free((void *)dnth);
  dnth=catstr(osimgdn, pt, 0);
  free(pt);
  if(access(dnth,0) && mkdir(dnth,0755) ){
	msgShow(dnth);
	msgShow(strerror(errno));
	return 0;
	}
}
return 1;
}

void ORDimagas(__ORL *lib, int argc,  char **argv) /*  ORD  to  os dir*/
{
struct stat64 st;
static const char self[]=".";
const char *osdir, *tmp;
int msg, brwVal[BrowsModeCnt];
memset(brwVal, 0, sizeof(int)*BrowsModeCnt);
ProcOpt 	releaOpt={
	BrowsModeCnt,
	releaChs, _releaChs,
	brwVal, 0, NULL, 0
	};
arglists *lst=procParas(argc, argv, &releaOpt, NULL);
__ORD *dir;
switch(lst->argc){
case 0 : ORtips(58, True); /* such as:  expoimg -n -d */
	showUsage(ORL_expoimg);
	goto _exit_;
case 1 : osdir=self;
	break;
default : osdir=lst->argv[1];
} 
msg=getBM(brwVal);
if((msg&3)==0)msg=1;
dir=DirOpen(lib->CurDir, (char *)lst->argv[0]);
if(idxdscpt>0x7ffd){
    if(stat64(osdir, &st)==0 && S_ISDIR(st.st_mode)){
	if(isRoot(dir)){
		char *pt=strrchr(lib->fname, '/');
		tmp=catstr(osdir, pt, 0);
		osimgdn=tmp;
		}
	else {
		tmp=catstr(osdir, dir->name, '/');
		osimgdn=osdir;
	}
	if(stat64(tmp, &st)==0){
		if( !S_ISDIR(st.st_mode)){
			msgShow("Create dir is a existed file !");
			goto _exit_;
		}
	}
	else if(mkdir(tmp,0755) ){
		msgShow(strerror(errno));
		goto _exit_;
	}
	dnth=tmp;
	ORDbrowth(dir, msg, n_expimg, d_expimg);
	if(dnth!=tmp)free((void *)dnth);
	if(osimgdn!=osdir)free((void *)osimgdn);
    }
    else {
	msgShow(osdir);
	defaultHB(NoOSDir_8);
	}
}
else reportBug();
_exit_: argsFree(lst);
}
