/*
	Write & edit by Linjianghua(Xempo) 2004-2006, 2010, 2014
	Free under LGPL
*/

#include "normal.h"
#include "numbtype.h"
#include "ordir.h"
#include "orlio.h"
#include "write.h"
#include "read.h"
#include "jxswitch.h"
#include "shellcom.h"
#include "stdfun.h"
#include "dialogid.def"
#include "infor.h"
#include "input.h"
#include "script.h"
#include "options.h"


#ifdef  _LINUX_SOURCE
#define  DiGueiLmt  400
#else 
#define  DiGueiLmt  35 // for DOS
#endif

int scpline, diguei,
	isRS/* use for infor.c or chdir(...) */;

char *scpbuf, *scpfname, memSepara[2];

const char DPdef[]="Permission denied", divsyb[]={13,10,32,9,0 }, separaChs[]=" \t",
quitScp[]="Press \'q\' to quit this running, press \'e\' to end this script, other continue";

#define	isSyb(txt)		((txt[-1]!='\"' || txt[1]!='\"') && (txt[-1]!='\'' || txt[1]!='\''))

inline char *NumBlack(char *dat, const char *end, MAU *send, unsigned int len, int style, BOOL abslen)
{/* free write first line after '{', end of data before '}' */
if(dat){
  int symb, _line=scpline;
  char *bufhd=dat, *bufend, *pt;
  BOOL rem_msg=False, zx_msg=False;
  while(rem_msg || zx_msg || (*bufhd!='{' || isSyb(bufhd)==False) ){
	if( zx_msg==False && ((*bufhd=='#'&&bufhd[1]=='!')||(cfgval[2]&&*bufhd=='/'&&bufhd[1]=='/')) ){
		rem_msg=True; bufhd++;
		scpline=_line;
		}
	else if( rem_msg==False && ((*bufhd=='<'&&bufhd[1]=='@')||(cfgval[2]&&*bufhd=='/'&&bufhd[1]=='*')) ){
		zx_msg=True; bufhd++;
		scpline=_line;
		}
	if((rem_msg==False&&zx_msg==False)&&strchr(divsyb,*bufhd)==NULL){
		pt=strchr(bufhd, '\n');
		if(pt){ 
			unsigned int L=pt-bufhd;
			memcpy(OutBuf, bufhd, L); OutBuf[L]=0;
			scpbuf=OutBuf;
			}
		else scpbuf=bufhd;
		ORtips(33, 1);
		return NULL;
	}
	if( (*bufhd=='@'&&bufhd[1]=='>')||(cfgval[2]&&*bufhd=='*'&&bufhd[1]=='/') ){
		zx_msg=False; bufhd++;
		}
	switch(*bufhd){
	case 13 : if(bufhd[1]==10)bufhd++;
	case 10 : _line++; 
		rem_msg=False;
	}
	if( ++bufhd>=end ){
		if(zx_msg)ORtips(49, 1);
		return NULL;
		}
  }
  bufhd++; /* bufhd[0]=='{' */
  scpline=_line;
  while( strchr(divsyb, *bufhd) ){
	switch(*bufhd){
	case '\r' : if(bufhd[1]=='\n')bufhd++;
	case '\n'  : _line++;
		if(style==_void||style==_txt){
			bufhd++;
			goto _out_;
		}
	}
	bufhd++;
  }
_out_: symb=0;
   for(bufend=bufhd; (unsigned int)(bufend-bufhd)<len; bufend++)
	switch(*bufend){
	case 13 : if(bufend[1]==10)bufend++;
	case 10 : _line++; break;
	case '{' : if(abslen==False && isSyb(bufend))symb++;
		break;
	case '}' :	if(abslen==False && isSyb(bufend) && symb--==0){
		if(bufend>bufhd){
		  pt=bufend-1;
		  while(/*pt>=bufhd&&*/strchr(divsyb,*pt)){
			if( (*pt==10|| *pt==13) && (style==_void||style==_txt) )break;
			pt++;
			}
		  if(strchr(divsyb, *pt)==NULL)pt++;
		  send->len=pt-bufhd;
		}
		else send->len=0;
	_ret_:	send->buf=bufhd;
		*bufend=0;/* for prnerr */
		scpline=_line;
		return bufend+1;
		}
	}
 /* len limt */
    while( !(*bufend=='}' && isSyb(bufend)) )bufend++;
    send->len=len;
    goto _ret_;
/* len limit */
}
ORtips(34, 1);
return NULL;
}

__ORL *ORLscript(__ORL *lib, char *pm, int msg, const char *inpPath)
{/* lib-program scriptor, read text file & tell __ORL how to autowork */
if(diguei<DiGueiLmt){/* limit for wrong script or safe */
  int dau, oldline, cntline=1, step, n, j, appendMsg=0, wr=-1,
 	numb, rdmsg=0;
  unsigned int Len, i, len;
  BOOL echomsg=False;
  char *ptline, *buf0, *buf2, *ptr, *oldscp, *buff, *fnam, *Pt, *cmd, *pthbuf=NULL, *next,
	zx_1, zx_2;
  diguei++;  fnam=pm;
  if( (isRS=(msg&1)) ){
       if(inpPath&&*fnam!='/')fnam=catstr(inpPath, fnam, '/');
       buff=ReadFile(fnam, &Len,False, orlX, &orlPaths);
  }
  else { buff=fnam; Len=strlen(buff); }
  buf0=buff;	buf2=buf0+Len;
  if(lib && (msg&2) ){
	rdmsg=NumLast(lib->CurDir);
	appendMsg=append_Mode;
	}
  if(inpPath==NULL){
	pthbuf=fullname(fnam);
	Pt=(char *)separChr(pthbuf);
	if(Pt)*Pt=0;
	inpPath=(const char *)pthbuf;
	}
  while(buff && buff<buf2 && CommNumb<ORL_quit/* 4096 */ ){
/* !=Quit_Script_Run  && !=End_Script_Run && !=ORL_exit(11520) &&!=ORL_quit */
/* ORL_quit(4096)quit abort prg result,  ORL_exit(11520)exit norml-exit */
      CommNumb=-20; step=0;
      if( (ptline=strchrs(buff, "\r\n")) ){
	if(*ptline=='\r' && ptline[1]=='\n')*ptline++=0;
	*ptline++=0;
	step=1;
      }
      else step=0;
      cmd=strdup(buff);
      if( remzx(cmd,NULL)<1 )goto _loop_;
      if(zxMsg==0 &&
	cfgval[2] && remzx(cmd,"///**/")<1 )goto _loop_;
      scpline=cntline;	scpbuf=cmd;	  scpfname=fnam;
      switch(zxMsg){
      case 1 : zx_1='@';	zx_2='>';
	goto _jmp2_;
      case 2 : zx_1='*';	zx_2='/';
_jmp2_:	if(ptline){
		while( ptline<buf2 && !(*ptline==zx_1 && ptline[1]==zx_2) ){
			switch(*ptline){
			case 13 : if(ptline[1]==10)ptline++;
			case 10 : cntline++;
			}
			ptline++;
			}
		if(ptline<buf2){
			ptline+=2;
			cmd[zxpos]=0;
			scpline=cntline;
			}
		else goto _lost_endzx;
		}
	else {
		_lost_endzx: ORtips(49, 1);
		goto _ex_loop_;
	}
      } /* switch */
      ptr=cmd;
_cont_run_:
      if( (next=strchr(ptr,';')) )*next++=0;
      if(echomsg)puts(ptr);
      scpbuf=ptr;
      Pt=strdup(ptr); /* for numbset or  error-info */
      lib=comRun(lib, Pt, appendMsg, inpPath);
      free(Pt);
      switch(CommNumb){
      case ORL_pause : msgShow(quitScp);
	idxdscpt=0x7fff;	/* safe */
	char qbu[8];
	if(getMsg)switch(popMsg(NULL,NULL, 3, orlX)){
		case 0 :  CommNumb=Quit_Script_Run; /* quit all script */
			break;
		case 1 : CommNumb=End_Script_Run; /* abort this script */
		}
	else switch(inCon(qbu,4)){
		case 'q' : CommNumb=Quit_Script_Run; /* quit all script */
		break;
		case 'e' :  CommNumb=End_Script_Run; /* end this script */
		}
	break;
      case ORL_echo : while(*ptr==32||*ptr==9)ptr++;
		if((ptr=strchrs(ptr, separaChs))!=NULL){
			while(*ptr==9||*ptr==32)ptr++;
			msgShow(ptr);
		}
		break;
      case echo_on : echomsg=True; break;
      case echo_off : echomsg=False; break;
      case ORL_sysnumbset :
      case ORL_numbset : { /* numbset, begin UXB  */
	MAU *send;
	char **argv;
	int *aLn, *Ln, *Lens, argc, M, T, tPos=FCU_TypePos(lib->CurDir->Format);
	BYTE *fcu, *type;
	idxdscpt=0x7fff;
	oldscp=scpbuf; oldline=cntline;
	dau=lib->CurDir->DAUC;
#define  mu2  5
	static const char *nmbattr[mu2]={"-l", "-m", "-t", "-a", "-u" }, *_nmbattr[mu2]={"--len","--mode","--type", "--alen","--unita" };
	int val[mu2];
	memset(val, 0, sizeof(int)*mu2);
	ProcOpt opt={mu2,nmbattr, _nmbattr, val, 0, NULL, 0};
	argc=0x7fff;
	argv=setargv(ptr, separaChs, &argc);
	arglists *alst=procParas(argc-1, argv+1, NULL, &opt);
	if(alst->argc){
		if(opt.errno)scriptTips(0);
		if(isNumb(alst->argv[0])==False){
			wr=popMsg(alst->argv[0], NULL, NumbsetErrorId, orlX)+5;
			goto _exitloop2_;
		}
		numb=atol(alst->argv[0])+rdmsg;
		unPara(alst, 1);
		if(alst->argc>1)scriptTips(0);
		}
	else {
		ORtips(I_None_58, True);
		showUsage(ORL_numbset);
		goto _out_;
	}
	const char *pidx, *hd,
		**subargv=(const char **)alst->subarg->argv;
	if(val[4] && (n=atoi(subargv[4]))<dau)dau=n;
	fcu=(unsigned char *)zalloc(dau*(2*sizeof(char)+2*sizeof(int)) + tPos );
	aLn=(int *)(fcu + tPos + dau);
	Ln=aLn+dau;
	type=(BYTE *)(Ln+dau);	memset(type,_sold,dau);/* use func less size than var init */
	fcu[1]=ORL_MR|ORL_MW;
	for(i=0; i<mu2-1; i++)
	   if(val[i])switch(i){
		case 0 :
		case 3 : 
		pidx=subargv[i];	Lens=i ? aLn : Ln;
		while(*pidx==32||*pidx==9)pidx++;
		hd=pidx;
		while( *pidx ){
		    if(*pidx==','){
			*Lens++=atol(hd);
			hd=++pidx;
		    }
		    else pidx++;
		}
		*Lens=atol(hd);
		break;
		case 1 : M=cvtPara(subargv[1], "rwho-");
			if(M<0)ORtips(43,True);
			else fcu[1]=M;
			break;
		case 2 :/* if val=null, default=_sold look init... */
		    pidx=subargv[2];
		    for(n=0,T=0,j=0;n<dau&&strchr(divsyb,pidx[n])==NULL;n++){
			if(T!=_separa)/* follow _separa, the char must skip */
			     T=fixType(type,j++,dau,pidx[n],pidx[n+1]);
/*			if(CommNumb==Quit_Script_Run||CommNumb==End_Script_Run)goto _exitloop_; */
			}
		}
	len=ptline-buf0;
	if(len>=Len)goto _exitloop1_;
	len=Len-len;
	send=MAUalloc(dau);
	for(j=0; j<dau; fcu[tPos+j++]=T )if((T=type[j])!=_none){
	  BOOL abslen=Ln[j]>0&&Ln[j]<len;
	  ptr=ptline;	  scpline=cntline;
	  ptline=NumBlack(ptr, buf2, send+j, abslen ? Ln[j] : len, T, abslen);
	  if(ptline==NULL){
		CommNumb=Quit_Script_Run;
		free(send);
	_exitloop1_:	free(fcu);
	_exitloop2_:	argsFree(alst); free(argv);
	_ex_loop_:	free(cmd);
		goto _exitloop_;
		}
	  send[j].alen=aLn[j];
	  cntline=scpline;
	  if(T==_txt || T==_sold ){
		int B;
		Pt=send[j].buf;
		B=fmtvalue(Pt, True);
		if(B<send[j].len){
			int b;
			for(b=0; b<B; b++)
				if(Pt[b]=='\\'&&Pt[b+1]=='\n'){
					strcut(Pt+b,1);	B--;
					}
			send[j].len=B;
			}
	  }
	  if(T!=_void){
		if(T==_separa)*memSepara=type[j+dau];
		T=putMAU(send+j,send[j].buf,T);
	  }
	} /* end for */
	if(lib){
	   if(idxdscpt>0x7ffd){
		scpline=oldline;/* perhan wnfcu occu error, so scpline(err-msg) must reset */
		scpbuf=oldscp;
		fmtFCU fmt={ fcu, numb, 0, 0 };
		lib->sys_Id_done=(CommNumb==ORL_sysnumbset);
		if(wnfcu(lib->CurDir, &fmt, send, dau)==False)wr=OverWrite;
		lib->sys_Id_done=False;
	   }
	   else reportBug();
	}
	for(j=0;j<dau;j++){
	     if((T=fcu[tPos+j])==_file||IsIntType(T))
		free(send[j].buf);
	}
	free(send); free(fcu);
	_out_: argsFree(alst); free(argv);
	} /* ORL_numbset  */
      }
      if(next){
	ptr=next;
	goto _cont_run_;
	}
_loop_:	free(cmd);
      buff=ptline;      cntline+=step;
  }
  _exitloop_: diguei--;
  isRS=(msg&1); /* use for infor.c or chdir(...) */
  if(pthbuf)free(pthbuf);
  if(fnam!=pm)free(fnam);
  if(buf0 && isRS )free(buf0);
  if(CommNumb==End_Script_Run)CommNumb=-20; /* only end this script */
	else if(CommNumb<ORL_quit){
		if(wr!=-1)CommNumb=wr;  /* pe write */
		else CommNumb=-20;/* disable -10 */
	}
  }
  return lib;
}
