/*
	Write & edit by Linjianghua(xempo)
	Copyright 2005 Linjianghua(xempo)
	Reserve all rights of file
*/
/* make handbook */

#include "readfile.c"

#ifdef	_LINUX_SOURCE
#include <unistd.h>
#define	stricmp	strcasecmp
#define DIV_CH   '/'
#else
#include <dos.h>
#define DIV_CH   '\\'
#endif

#include <time.h>
#include <sys/stat.h>
#include "memstr.c"

static const char memblkcmp[]={ 10, 32, 9, ',' , ';' , 0};

static int ToNextLen(const char *pt)
{
  int i;
  for(i=0; strchr("\r\n\t ",pt[i]); i++);
  return i;
}

int main(int argc,char **argv)
{
static const char usageChs[]="Usage : mkhb [hbfile] |[indexfile] |[--pure] |[--htm] |[--case] |[--void] |[--free] |[-d outdir]\n\
\t--pure   out pure text file\n\
\t--htm  out htm file\n\
\tno above 2, out is OpenRose-script\n\
\t--case   file-data compare case\n\
\t--void  specied type is void\n\
\t--free  cut 2 side [Enter] or [Space] [tab]\n\
	default is cvt dos-mode to Unix-mode(t)\n\
\t-d   specied dir follow as out !\n\
\nFreely txt-mode, separator is 2[Enter]\n\n",

htmhd[]="<html>\n\
<head>\n\
<style>\n\
\t.funame {\n\
\t\tfont-family: \"DejaVu Serif\";\n\
\t\tfont-weight: 800;\n\
\t\tcolor: #3734FD;\n\
\t\tfont-size: 18pt;\n\
\t}\n\
</style>\n\
</head>\n\
<body bgcolor=#f0f0f0>\n\
<pre>\n\
<font face=\"DejaVu Serif\" size=3>\n",

htmext[]=".htm", cmdext[]=".cmd";

if(argc>1){
#define  para_cnt  6
#define  _line1  '#'
#define  _line2  '!'
  FILE *fout, *fhlp=NULL, *fcmd;
  static const char wb[]="wb", cmdnam[]="comm.htm",
	*params[para_cnt]={ "--pure", "--htm", "--case", "--void", "--free", "-d" };
  const char *srcfile=NULL, *idxfile=NULL, *dstdir=NULL;
  char *idxbuf, **DScpt, *pt, *ptr, *pth, type='t', *cap,
	outfile[1024], 	fn[260];
  unsigned int idxlen, src_cnt, src_len, i, j, b, sc, t, L,
	cmplen, wlen, nxlen, nmb=0;
  struct stat st;
  int sw[para_cnt];
  memset(sw, 0, sizeof(sw));
  i=1;
  while(i<(unsigned int)argc){
	pt=argv[i];
	for(j=0; j<para_cnt; j++)
		if(stricmp(pt,params[j])==0){
		  pt=argv[i+1];
		  switch(j){
		  case 3 : type='v';
			break;
		  case 4 : type='y';
			break;
		  case para_cnt-1 : if(i+1<(unsigned int)argc){ /* else error will show after. */
			    for(b=0; b<para_cnt; b++)
				if(stricmp(pt,params[b])==0){
					printf("%s is parameter, can't use as out-dir for \"-d\"\n", pt);
					goto _ex2_;
					}
			    if(stat(pt, &st)==0&&(st.st_mode&S_IFDIR)){
				if(dstdir){
					printf("Out dir has specied \"%s\", \"%s\" not be use !\n", dstdir, pt);
					goto _ex2_;
				}
				dstdir=argv[++i];
				}
			    else {
				printf("\"-d\" specied \"%s\" is not existed dir !\n", pt);
				goto _ex2_;
				}
			}
		  default : sw[j]=1;
		  }
		   goto _jmp_;
		}/* end for (j...) */

	if(j>(para_cnt-1) && dstdir!=pt){
		if(srcfile==NULL){
			if(stat(pt, &st)==0&&!(st.st_mode&S_IFDIR))srcfile=pt;
			else goto _err_;
			}
		else if(idxfile==NULL){
			if(stat(pt, &st)==0&&!(st.st_mode&S_IFDIR))idxfile=pt;
			else goto _err_;
			}
		     else _err_: printf(" ** %s is unuseful params\n", pt);
	}
_jmp_:	i++;
    }
/*=========== get descript(poors) begin ===================*/  
  pt=strchr(*argv,DIV_CH);
  if(pt){ _ProgPath=*argv; *pt=0; }

  if(idxfile && !(idxbuf=ReadFile(idxfile, &idxlen)) )
	return 3;

  if(srcfile==NULL){
	printf("No src file !\n%s",usageChs);
	return 1;
	}
  if( !(pt=ReadFile(srcfile,&src_len))) return 2; 
  for(pt[src_len]=0,i=src_len-1;i>0&&pt[i]==10;i--,src_len--)pt[i]=0;
  for(src_cnt=1,i=0;i<src_len;i++)
	if(pt[i]==10 && pt[i+1]==10 ){
		src_cnt++; pt[i]=0;
		if(i<src_len){
		  j=ToNextLen(pt+i+2);
		  if(j>0)i+=j-1;/* as i++ in loop */
		}
	}
  DScpt=(char **)malloc(src_cnt*sizeof(char *));
  *DScpt=pt;
  for(j=1,i=0; i<src_len&&j<src_cnt; i++)if(pt[i]==0){
	nxlen=ToNextLen(pt+i);
	DScpt[j++]=pt+i+nxlen;
/*	printf("nx=%d, %s",i+nxlen,DScpt[j-1]);*/
  }
/*=========== get descript(poors) end ======================*/
  ptr=(char *)malloc(strlen(srcfile)+8);
  strcpy(ptr, srcfile);	srcfile=ptr;
  pt=strrchr(srcfile,'.');
  if(pt)strcpy(pt, sw[1] ? htmext : ".out");
  if(sw[para_cnt-1]){
	if(dstdir){
		L=strlen(dstdir);
		strcpy(outfile, dstdir);
		pt=strrchr(srcfile, DIV_CH);
		if(pt){
			if(dstdir[L-1]==DIV_CH)L--;
			strcpy(outfile+L, pt);
		}
		else { outfile[L++]=DIV_CH; strcpy(outfile+L, srcfile); }
		if(sw[1])ptr=catstr(dstdir, cmdnam, DIV_CH);
	}
	else {
		printf("A dir must follow \"-d\" for out !\n");
		goto _ex2_;
	}
	}
  else  _setsrc_: {
	strcpy(outfile, srcfile);
	if(sw[1])ptr=cmdnam;
	}

  fout=fopen(outfile, wb);
  if(sw[1]){
static const char cmdhd[]="<html>\n<body bgcolor=#5cabff link=#f0f0f0 vlink=#0f0f0f marginheight=15>\n\
<pre> <font face=\"DejaVu Serif\" size=4><b>\n";
	fcmd=fopen(ptr, wb);
	fprintf(fcmd, cmdhd);
	fprintf(fout, htmhd);
	
	}
  if(idxfile)idxlen++;
  else goto _src_lists_;

  for(sc=0,i=0,b=0; i<idxlen && sc<src_cnt; i++)
    if(strchr(memblkcmp,idxbuf[i])){
    pt=idxbuf+b;    cmplen=i-b;
    if(pt[0]==_line1&&pt[1]==_line2){
static const char hlphd[]="<html>\n<body bgcolor=#b0b6b9 vlink=#3029f0 marginheight=15>\n<pre>\n\
<font face=\"DejaVu Serif\" size=4><b>\n",
hlpend[]="</b>\n</font>\n</pre>\n</body>\n</html>";
	unsigned int c=i, k=0;
	if(fhlp){
		fprintf(fhlp, hlpend);
		fclose(fhlp);
	}
	for(t=2; pt[t]!='\n'&&pt[t]; t++){
		if(k || pt[t]!=32&&pt[t]!=9 )fn[k++]=pt[t];
		if(pt+t>idxbuf+c)i++;
		}
	while(pt[t]=='\n'){ t++; i++; }
	if(sw[1]){
	    k--;
	    while(fn[k]==32||fn[k]==9)k--;
	    fn[++k]=0;
	    if(memstr(fn, k+1, cmdext, sizeof(cmdext)-1, 1|2)){
		cap=strchr(fn, '/');
		if(cap){
			ptr=cap-1;
			while(*ptr==32||*ptr==9)ptr--;
			ptr[1]=0;
			*cap++=0;
			while(*cap==32 || *cap==9)cap++;
		}
		else cap=fn;
//		char *fn=catstr(buf, htmext, '.');
		if(dstdir)pth=catstr(dstdir, fn, DIV_CH);
		else pth=strdup(fn);
/*		printf("html=%s!\n",pth); */
		fhlp=fopen(pth, wb);
		fprintf(fhlp, hlphd);
		fprintf(fcmd, "  <a href=\"%s\">%s</a>\n", fn, cap);
	    }
	}
	b=i+1;
	continue;
	}
    idxbuf[i]=0; b=i+1;
    if(cmplen>0){
_src_lists_:
	for(j=0;j<src_cnt;j++){/* src-lists */
	  ptr=DScpt[j];
	  if(idxfile==NULL || (
		ptr[cmplen]==':'&&memstr(ptr,cmplen,pt,cmplen,1|(sw[1]*2))) ){

	    wlen=strlen(ptr);	sc++;
	    if(ptr[wlen-1]!='\n'){
		ptr[wlen]='\n';	wlen++;
		}
	/*    if(cn<n){ ptr[wlen]='\n'; wlen++; }*/
	    if(*sw/* --pure */){
		while(*ptr!=10){
			ptr++;		wlen--;
			}
		wlen--;
		if(*ptr==10)ptr++;
	    }
	    else {
		if(sw[1]){
			pt[cmplen]=0;
			fprintf(fout,"<a name=\"_%s_\" class=\"funame\" >%s</a>: \n", pt, pt);
			fprintf(fhlp, "   <a href=\"%s#_%s_\" target=\"BODY\">%s</a>\n", srcfile, pt, pt);
		}
		else fprintf(fout,"numbset %d -t=%c  -l=%d\n{\n", nmb, type, wlen-1);
		}
	    fwrite(ptr,wlen,1,fout);
	    fwrite(*sw||sw[1] ? "\n" : "}\n\n", *sw||sw[1] ? 1 : 3 , 1,fout);
	    if(idxfile)break;
	    else nmb++;
	   }
       }/* src-lists end */
       if(idxfile==NULL)goto _ex_;
       if(j>=src_cnt){
		fprintf(fout,"numbset %d -t=t\n{\n", nmb);
		fwrite(pt,cmplen,1,fout);
		fprintf(fout, ": ...\n}\n\n");
		}
	nmb++;
    }
    else break;
  }
/*  free(idxbuf); redure code */
/* free(*DScpt);free(DScpt); */
_ex_: if(sw[1]){
	fprintf(fcmd, "</b>\n</font>\n</pre>\n</body>\n</html>");
	fclose(fcmd);
	fprintf(fout, "</font>\n</pre>\n</body>\n</html>");
	}
  fclose(fout);
  printf("Create \"%s\" successfully\n",outfile);
  return 0; /* for make.exe */
}
_ex2_: printf(usageChs);
return 90;
}
